/* main-status-icon.c generated by valac, the Vala compiler
 * generated from main-status-icon.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (C) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include <glib.h>
#include <glib-object.h>
#include <libnotes.h>
#include <gtk/gtk.h>
#include <libxfce4util/libxfce4util.h>
#include <config.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <popup.h>
#include <gdk/gdk.h>
#include <unique/unique.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))


extern XnpApplication* application;
XnpApplication* application = NULL;
extern GtkInvisible* invisible;
GtkInvisible* invisible = NULL;
extern GtkStatusIcon* status_icon;
GtkStatusIcon* status_icon = NULL;
extern GtkMenu* context_menu;
GtkMenu* context_menu = NULL;

static gboolean _lambda0_ (void);
static gboolean __lambda0__gsource_func (gpointer self);
static void _lambda1_ (void);
static void __lambda1__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self);
GtkMenu* build_context_menu (void);
static void _gtk_status_icon_position_menu_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
static void _lambda5_ (void);
static void __lambda5__gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self);
gboolean set_x_selection (void);
void build_plugin (void);
static void _lambda2_ (void);
static void __lambda2__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _lambda3_ (void);
static void __lambda3__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _lambda4_ (void);
static void __lambda4__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static gboolean _lambda6_ (GtkInvisible* w, GdkEventClient* event);
static gboolean __lambda6__gtk_widget_client_event (GtkInvisible* _sender, GdkEventClient* event, gpointer self);
static UniqueResponse _lambda7_ (gint command, UniqueMessageData* message_data, guint time_);
static UniqueResponse __lambda7__unique_app_message_received (UniqueApp* _sender, gint command, UniqueMessageData* message_data, guint time_, gpointer self);
gint _main (char** args, int args_length1);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gboolean _lambda0_ (void) {
	gboolean result;
	if (!gtk_status_icon_is_embedded (status_icon)) {
		g_warning ("main-status-icon.vala:37: Status Icon is not embedded");
		gtk_main_quit ();
	}
	result = FALSE;
	return result;
}


static gboolean __lambda0__gsource_func (gpointer self) {
	return _lambda0_ ();
}


static void _lambda1_ (void) {
	xnp_application_show_hide_notes (application);
}


static void __lambda1__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self) {
	_lambda1_ ();
}


static void _gtk_status_icon_position_menu_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	gtk_status_icon_position_menu (menu, x, y, push_in, self);
}


static void _lambda5_ (void) {
	gtk_menu_popup (context_menu, NULL, NULL, _gtk_status_icon_position_menu_gtk_menu_position_func, status_icon, (guint) 0, gtk_get_current_event_time ());
}


static void __lambda5__gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self) {
	_lambda5_ ();
}


void build_plugin (void) {
	char* save_location;
	XnpApplication* _tmp0_;
	GtkStatusIcon* _tmp1_;
	GtkMenu* _tmp2_;
	xfce_textdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR, NULL);
	save_location = g_strdup (xfce_resource_save_location (XFCE_RESOURCE_CONFIG, "xfce4/xfce4-notes.rc", TRUE));
	application = (_tmp0_ = xnp_application_new (save_location), _g_object_unref0 (application), _tmp0_);
	status_icon = (_tmp1_ = gtk_status_icon_new_from_icon_name ("xfce4-notes-plugin"), _g_object_unref0 (status_icon), _tmp1_);
	gtk_status_icon_set_tooltip (status_icon, _ ("Notes"));
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 60, __lambda0__gsource_func, NULL, NULL);
	g_signal_connect (status_icon, "activate", (GCallback) __lambda1__gtk_status_icon_activate, NULL);
	context_menu = (_tmp2_ = build_context_menu (), _g_object_unref0 (context_menu), _tmp2_);
	g_signal_connect (status_icon, "popup-menu", (GCallback) __lambda5__gtk_status_icon_popup_menu, NULL);
	set_x_selection ();
	_g_free0 (save_location);
}


static void _lambda2_ (void) {
	xnp_application_open_settings_dialog (application);
}


static void __lambda2__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda2_ ();
}


static void _lambda3_ (void) {
	xnp_application_open_about_dialog (application);
}


static void __lambda3__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda3_ ();
}


static void _lambda4_ (void) {
	xnp_application_save_notes (application);
	xfce_autostart_set ("xfce4-notes-autostart", "xfce4-notes", TRUE);
	gtk_main_quit ();
}


static void __lambda4__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda4_ ();
}


GtkMenu* build_context_menu (void) {
	GtkMenu* result;
	GtkMenu* menu;
	GtkMenuItem* mi;
	GtkMenu* menu_go;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	menu = g_object_ref_sink ((GtkMenu*) gtk_menu_new ());
	mi = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Groups")));
	menu_go = xnp_application_context_menu (application);
	gtk_menu_item_set_submenu (mi, (GtkWidget*) menu_go);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) mi);
	mi = (_tmp0_ = (GtkMenuItem*) g_object_ref_sink ((GtkSeparatorMenuItem*) gtk_separator_menu_item_new ()), _g_object_unref0 (mi), _tmp0_);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) mi);
	mi = (_tmp1_ = (GtkMenuItem*) g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_PROPERTIES, NULL)), _g_object_unref0 (mi), _tmp1_);
	g_signal_connect (mi, "activate", (GCallback) __lambda2__gtk_menu_item_activate, NULL);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) mi);
	mi = (_tmp2_ = (GtkMenuItem*) g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_ABOUT, NULL)), _g_object_unref0 (mi), _tmp2_);
	g_signal_connect (mi, "activate", (GCallback) __lambda3__gtk_menu_item_activate, NULL);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) mi);
	mi = (_tmp3_ = (GtkMenuItem*) g_object_ref_sink ((GtkSeparatorMenuItem*) gtk_separator_menu_item_new ()), _g_object_unref0 (mi), _tmp3_);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) mi);
	mi = (_tmp4_ = (GtkMenuItem*) g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_REMOVE, NULL)), _g_object_unref0 (mi), _tmp4_);
	g_signal_connect (mi, "activate", (GCallback) __lambda4__gtk_menu_item_activate, NULL);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) mi);
	gtk_widget_show_all ((GtkWidget*) menu);
	result = menu;
	_g_object_unref0 (mi);
	_g_object_unref0 (menu_go);
	return result;
}


static gboolean _lambda6_ (GtkInvisible* w, GdkEventClient* event) {
	gboolean result;
	g_return_val_if_fail (w != NULL, FALSE);
	if (_vala_strcmp0 (popup_get_message_from_event (event), "SHOW_HIDE") == 0) {
		xnp_application_show_hide_notes (application);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean __lambda6__gtk_widget_client_event (GtkInvisible* _sender, GdkEventClient* event, gpointer self) {
	return _lambda6_ (_sender, event);
}


gboolean set_x_selection (void) {
	gboolean result;
	GtkInvisible* _tmp0_;
	invisible = (_tmp0_ = g_object_ref_sink ((GtkInvisible*) gtk_invisible_new ()), _g_object_unref0 (invisible), _tmp0_);
	if (!popup_set_x_selection ((GtkWidget*) invisible)) {
		result = FALSE;
		return result;
	}
	g_signal_connect ((GtkWidget*) invisible, "client-event", (GCallback) __lambda6__gtk_widget_client_event, NULL);
	result = TRUE;
	return result;
}


static UniqueResponse _lambda7_ (gint command, UniqueMessageData* message_data, guint time_) {
	UniqueResponse result;
	g_return_val_if_fail (message_data != NULL, 0);
	if (command != UNIQUE_ACTIVATE) {
		result = UNIQUE_RESPONSE_PASSTHROUGH;
		return result;
	}
	result = UNIQUE_RESPONSE_OK;
	return result;
}


static UniqueResponse __lambda7__unique_app_message_received (UniqueApp* _sender, gint command, UniqueMessageData* message_data, guint time_, gpointer self) {
	return _lambda7_ (command, message_data, time_);
}


gint _main (char** args, int args_length1) {
	gint result;
	UniqueApp* app;
	gboolean _tmp0_;
	XnpApplication* _tmp2_;
	GtkInvisible* _tmp3_;
	GtkStatusIcon* _tmp4_;
	GtkMenu* _tmp5_;
	gtk_init (&args_length1, &args);
	app = unique_app_new ("org.xfce.Notes", NULL);
	if ((g_object_get (app, "is-running", &_tmp0_, NULL), _tmp0_)) {
		if (unique_app_send_message (app, (gint) UNIQUE_ACTIVATE, NULL) == UNIQUE_RESPONSE_OK) {
			UniqueApp* _tmp1_;
			app = (_tmp1_ = NULL, _g_object_unref0 (app), _tmp1_);
			result = 0;
			_g_object_unref0 (app);
			return result;
		}
	}
	g_signal_connect (app, "message-received", (GCallback) __lambda7__unique_app_message_received, NULL);
	g_set_application_name (_ ("Notes"));
	build_plugin ();
	xfce_autostart_set ("xfce4-notes-autostart", "xfce4-notes", FALSE);
	gtk_main ();
	application = (_tmp2_ = NULL, _g_object_unref0 (application), _tmp2_);
	invisible = (_tmp3_ = NULL, _g_object_unref0 (invisible), _tmp3_);
	status_icon = (_tmp4_ = NULL, _g_object_unref0 (status_icon), _tmp4_);
	context_menu = (_tmp5_ = NULL, _g_object_unref0 (context_menu), _tmp5_);
	result = 0;
	_g_object_unref0 (app);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return _main (argv, argc);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




